
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InvitesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invites = await db.invites.create(
            {
                id: data.id || undefined,
        
        message: data.message
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        responded_at: data.responded_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await invites.setSender( data.sender || null, {
            transaction,
        });
        
        await invites.setReceiver( data.receiver || null, {
            transaction,
        });
        
        await invites.setGig( data.gig || null, {
            transaction,
        });
        

        

        

        return invites;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const invitesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                message: item.message
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                responded_at: item.responded_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const invites = await db.invites.bulkCreate(invitesData, { transaction });

        // For each item created, replace relation files
        

        return invites;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const invites = await db.invites.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.message !== undefined) updatePayload.message = data.message;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.responded_at !== undefined) updatePayload.responded_at = data.responded_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await invites.update(updatePayload, {transaction});

        
        
        if (data.sender !== undefined) {
            await invites.setSender(
              
              data.sender,
              
              { transaction }
            );
        }
        
        if (data.receiver !== undefined) {
            await invites.setReceiver(
              
              data.receiver,
              
              { transaction }
            );
        }
        
        if (data.gig !== undefined) {
            await invites.setGig(
              
              data.gig,
              
              { transaction }
            );
        }
        

        
        

        

        return invites;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const invites = await db.invites.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of invites) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of invites) {
                await record.destroy({transaction});
            }
        });


        return invites;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const invites = await db.invites.findByPk(id, options);

        await invites.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await invites.destroy({
            transaction
        });

        return invites;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const invites = await db.invites.findOne(
            { where },
            { transaction },
        );

        if (!invites) {
            return invites;
        }

        const output = invites.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.sender = await invites.getSender({
            transaction
        });
        
        
        output.receiver = await invites.getReceiver({
            transaction
        });
        
        
        output.gig = await invites.getGig({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'sender',
        
        where: filter.sender ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sender.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.sender.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'receiver',
        
        where: filter.receiver ? {
          [Op.or]: [
            { id: { [Op.in]: filter.receiver.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.receiver.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.gigs,
        as: 'gig',
        
        where: filter.gig ? {
          [Op.or]: [
            { id: { [Op.in]: filter.gig.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.gig.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'invites',
                        'message',
                        filter.message,
                    ),
                };
            }
            

            
            

            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.responded_atRange) {
                const [start, end] = filter.responded_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    responded_at: {
                    ...where.responded_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    responded_at: {
                    ...where.responded_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.invites.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'invites',
                        'message',
                        query,
                    ),
                ],
            };
        }

        const records = await db.invites.findAll({
            attributes: [ 'id', 'message' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['message', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.message,
        }));
    }

    
};

